using System;
using System.IO;
using Twitchbot.Core;
using Twitchbot.Util;
namespace REPLACE.WITH.PLUGIN.NAME
{
    [ApiVersion(0, 1)]
    public class Plugin : Twitchbot
    {
        public Plugin()
        {
        }
        public override Version Version => new Version(0, 1, 0, 0);
        public override string Name => "REPLACE-WITH-PLUGIN-NAME";
        public override void Initialize() {
            Bot.PingEvent += OnPing;
            Bot.AllReceivedEvent += OnAll;
            Bot.MessageReceivedEvent += OnMessage;
            Bot.UserJoinEvent += OnJoin;
            Bot.UserCommandEvent += OnCommand;
            Counter.TimerElapsedEvent += OnTimerExpire;
        }
        private void OnPing(object sender, EventArgs e)
        {
            //PingEvent
        }
        private void OnAll(object sender, Bot.AllReceivedArgs e)
        {
            string cmd = e.Message.ToLower();
            //AllReceivedEvent
        }
        private void OnMessage(object sender, Bot.MessageReceivedArgs e)
        {
            string cmd = e.Message.ToLower();
            //MessageReceivedEvent
        }
        private void OnJoin(object sender, Bot.JoinEventArgs e)
        {
            chat.SendMessage("Welcome " e.UserName);
            //UserJoinEvent
        }
        private void OnCommand(object sender, Bot.CommandEventArgs e)
        {
            if (cmd == "rules") {
                chat.SendMessage(e.UserName + "<rules go here>");
            }

            if (cmd == "welcome") {
                chat.SendMessage(e.UserName + "Please read the rules in !rules");
            }

            if (cmd == "commands") {
                chat.SendMessage("!welcome !rules");
            }

            string cmd = e.Message.Substring(1).ToLower();
            //UserCommandEvent
        }
        private void OnTimerExpire(object sender, ElapsedArgs e)
        {
            //TimerElapsedEvent
            //Do note: use Counter.StartCounter(...) to light this method
        }
        public override void Dispose() {
            Bot.PingEvent -= OnPing;
            Bot.AllReceivedEvent -= OnAll;
            Bot.MessageReceivedEvent -= OnMessage;
            Bot.UserJoinEvent -= OnJoin;
            Bot.UserCommandEvent -= OnCommand;
        }
    }
}
